#include "para.h"

long unsigned tv2ms(const struct timeval *tv)
{
	return tv->tv_sec * 1000 + (tv->tv_usec + 500)/ 1000; 
}

/* compute b - a. if b < a, return -1 */
int tv_diff(struct timeval *b, struct timeval *a, struct timeval *diff)
{
	if ((b->tv_sec < a->tv_sec) || 
		((b->tv_sec == a->tv_sec) && (b->tv_usec < a->tv_usec)))
		return -1;
	if (!diff)
		return 1;
	diff->tv_sec = b->tv_sec - a->tv_sec;
	if (b->tv_usec < a->tv_usec) {
		diff->tv_sec--;
		diff->tv_usec = 1000 * 1000 - a->tv_usec + b->tv_usec;
	} else
		diff->tv_usec = b->tv_usec - a->tv_usec;
	return 1;
}

/* 
 * convert double to struct timeval 
 */
void d2tv(double x, struct timeval *tv)
{
	tv->tv_sec = x;
	tv->tv_usec = (x - (double)tv->tv_sec) * 1000 * 1000 + 0.5;
}


/*
 * add two structs of type timeval 
 */
void tv_add(const struct timeval *a, const struct timeval *b, 
	struct timeval *sum)
{
	sum->tv_sec = a->tv_sec + b->tv_sec;
	if (a->tv_usec + b->tv_usec >= 1000 * 1000) {
		sum->tv_sec++;
		sum->tv_usec = a->tv_usec + b->tv_usec - 1000 * 1000; 
	} else
		sum->tv_usec = a->tv_usec + b->tv_usec;
}

